/*
 * Copyright 2010 Google Inc.
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except
 * in compliance with the License. You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License
 * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express
 * or implied. See the License for the specific language governing permissions and limitations under
 * the License.
 */
/*
 * This code was generated by https://code.google.com/p/google-apis-client-generator/
 * (build: 2013-06-05 16:09:48 UTC)
 * on 2013-06-11 at 10:54:54 UTC 
 * Modify at your own risk.
 */

package com.google.api.services.bigquery.model;

/**
 * Model definition for JobConfigurationExtract.
 *
 * <p> This is the Java data model class that specifies how to parse/serialize into the JSON that is
 * transmitted over HTTP when working with the BigQuery API. For a detailed explanation see:
 * <a href="http://code.google.com/p/google-http-java-client/wiki/JSON">http://code.google.com/p/google-http-java-client/wiki/JSON</a>
 * </p>
 *
 * @author Google, Inc.
 */
@SuppressWarnings("javadoc")
public final class JobConfigurationExtract extends com.google.api.client.json.GenericJson {

  /**
   * [Experimental] Optional and defaults to CSV. Format with which files should be exported. To
   * export to CSV, specify "CSV". Tables with nested or repeated fields cannot be exported as CSV.
   * To export to newline-delimited JSON, specify "NEWLINE_DELIMITED_JSON".
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String destinationFormat;

  /**
   * [Required] The fully-qualified Google Cloud Storage URI where the extracted table should be
   * written.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String destinationUri;

  /**
   * [Optional] Delimiter to use between fields in the exported data. Default is ','
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.String fieldDelimiter;

  /**
   * [Optional] Whether to print out a heder row in the results. Default is true.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private java.lang.Boolean printHeader;

  /**
   * [Required] A reference to the table being exported.
   * The value may be {@code null}.
   */
  @com.google.api.client.util.Key
  private TableReference sourceTable;

  /**
   * [Experimental] Optional and defaults to CSV. Format with which files should be exported. To
   * export to CSV, specify "CSV". Tables with nested or repeated fields cannot be exported as CSV.
   * To export to newline-delimited JSON, specify "NEWLINE_DELIMITED_JSON".
   * @return value or {@code null} for none
   */
  public java.lang.String getDestinationFormat() {
    return destinationFormat;
  }

  /**
   * [Experimental] Optional and defaults to CSV. Format with which files should be exported. To
   * export to CSV, specify "CSV". Tables with nested or repeated fields cannot be exported as CSV.
   * To export to newline-delimited JSON, specify "NEWLINE_DELIMITED_JSON".
   * @param destinationFormat destinationFormat or {@code null} for none
   */
  public JobConfigurationExtract setDestinationFormat(java.lang.String destinationFormat) {
    this.destinationFormat = destinationFormat;
    return this;
  }

  /**
   * [Required] The fully-qualified Google Cloud Storage URI where the extracted table should be
   * written.
   * @return value or {@code null} for none
   */
  public java.lang.String getDestinationUri() {
    return destinationUri;
  }

  /**
   * [Required] The fully-qualified Google Cloud Storage URI where the extracted table should be
   * written.
   * @param destinationUri destinationUri or {@code null} for none
   */
  public JobConfigurationExtract setDestinationUri(java.lang.String destinationUri) {
    this.destinationUri = destinationUri;
    return this;
  }

  /**
   * [Optional] Delimiter to use between fields in the exported data. Default is ','
   * @return value or {@code null} for none
   */
  public java.lang.String getFieldDelimiter() {
    return fieldDelimiter;
  }

  /**
   * [Optional] Delimiter to use between fields in the exported data. Default is ','
   * @param fieldDelimiter fieldDelimiter or {@code null} for none
   */
  public JobConfigurationExtract setFieldDelimiter(java.lang.String fieldDelimiter) {
    this.fieldDelimiter = fieldDelimiter;
    return this;
  }

  /**
   * [Optional] Whether to print out a heder row in the results. Default is true.
   * @return value or {@code null} for none
   */
  public java.lang.Boolean getPrintHeader() {
    return printHeader;
  }

  /**
   * [Optional] Whether to print out a heder row in the results. Default is true.
   * @param printHeader printHeader or {@code null} for none
   */
  public JobConfigurationExtract setPrintHeader(java.lang.Boolean printHeader) {
    this.printHeader = printHeader;
    return this;
  }

  /**
   * [Required] A reference to the table being exported.
   * @return value or {@code null} for none
   */
  public TableReference getSourceTable() {
    return sourceTable;
  }

  /**
   * [Required] A reference to the table being exported.
   * @param sourceTable sourceTable or {@code null} for none
   */
  public JobConfigurationExtract setSourceTable(TableReference sourceTable) {
    this.sourceTable = sourceTable;
    return this;
  }

  @Override
  public JobConfigurationExtract set(String fieldName, Object value) {
    return (JobConfigurationExtract) super.set(fieldName, value);
  }

  @Override
  public JobConfigurationExtract clone() {
    return (JobConfigurationExtract) super.clone();
  }

}
